08/16/2004 (version 2.40)
----------
1. unofficial maildir patch for openwebmail 2.32 in download/contrib/
   it is based on the Laurent Frigault's implementation in 2.01.
   (thanks to Varadi Gabor, varadi.AT.mithrandir.hu for his patch)
2. skip readprefs if euid !=0 && euid!=uuid in openwebmail.pl
   so ther won't premission error when user home is located on nfs server 
   with uid 0 mapping disabled
   (reported by cchs92.AT.cs.ccu.edu.tw)


08/14/2004
----------
1. new mirror site: http://www.openwebmail.nl/


08/13/2004
----------
1. zh_HK.Big5, en_HK holiday file update
   (thanks to faifai.AT.users.sourceforge.net)


08/12/2004
----------
1. new mail sound: YouGotMail.German.wav
   (thanks to Helmut Grund, Helmut.Grund.AT.fh-furtwangen.de)
2. check message existence in message attribute retrival to eliminate 
   unnecessary warning of corrupted index
   (reported by James Briggs, james.AT.ActionMessage.com)


08/09/2004
----------
1. fix the "Undefined subroutine &main::get_info_messageids_sorted_by_date"
   error in openwebmail-advearch.pl and shares/cut.pl
   (reported by jaca.AT.jaca.hu)


08/07/2004
----------
1. new mail sound: YouGotMail.Korean.wav 
   (thanks to Youngho Kang, ykang.AT.deskweb.net)
2. check if subject is 'N/A' before sending message in composemessage.template
   (suggested by jsveiga, openwebmail.AT.rf.com.br)
3. include owm-stats-1.1.zip in cgi-bin/openwebmail/misc/tools/owm-stats/
   (thanks to Dimitrios 'sehh' Michelinakis, dimitrios.AT.michelinakis.gr)
4. fix a bug move_oldmsg_from_folder in maildb.pl which just moved new 
   messages from INBOX to SAVED folder
   (reported by James Briggs, james.AT.ActionMessage.com)


08/06/2004
----------
1. fix a bug that repeat filter may counter a message for more than once
   if that message has been already verified by other process.
   (thanks to James Briggs, james.AT.ActionMessage.com for his hint
    and help in debugging this problem)


08/05/2004
----------
1. fix the bug in spamcheck.pl that negative spamlevel is always read as 
   positive
   (thanks xtremebassist.AY.basslessons.net for his fix)
2. fix the bug in mailfilter that spammail will be moved to virus_destination 
   instead of spam_destinaion
   (thanks to xtremebassist.AY.basslessons.net for his fix)
3. index.html, readme.txt documenu update


08/04/2004
----------
1. Indonesian language and template translation update
   (thanks to James Briggs, james.AT.ActionMessage.com)
2. fix the bug that new messages counter won't change after reading
   a new message. this bug was introduce by the 20040802 fix
   (reported by stevenchow.AT.lichking.com)
3. clean code for zapped messages
   there are 4 types of message in a folder: zapped, internal, new, read
4. fix bugs in repeated message filter in mailfilter.pl
   a. messages of same sender/subject were counted for only once
   b. old messages may be filtered because the index db recreation would
      make all messages appeare as new at once. 
   c. the id of repeated msgs were not logged correctly when 
      log_filtermove_detail is on

ps: the db format is changed slightly in this release,
    we suggest the system to execute the following command to avoid possible
    delay cuased by reindex at user runtime.

    /path_to_openwbemail/openwebmail-tool.pl -i -a 


08/03/2004
----------
1. check pipe open/write error in spamcheck/viruscheck


08/02/2004
----------
1. add a field 'LSTMTIME' to index db to mark the modified time of the
   message list, and getmsgids.pl only reload the message ids from index db
   when the LSTMTIME is changed.
   This speeds up the msglist retrival, especially for folders with lots of 
   messages (eg: more than 1000)


07/30/2004
----------
1. fix the problem that pop3 fetchmail may hang in data retrival if remote
   pop3 server disconnected unexpectedly


07/29/2004
----------
1. Catalan language and template files translation update
   (thanks to Jordi Sanfeliu, mikaku.AT.fiwix.org)
2. Italian language and template files translation update
   (thanks to Benedet Marvi, marvi.AT.menhir.biz)


07/28/2004
----------
1. zh_CN.GB2312 language and template files translation update
   (thanks to Wang Jun, irixer.AT.hotmail.com)
2. fix a bug in mailfilter that viruscheck/spamcheck won't be 
   issued if there is no filter rule in both global and per user 
   filter book.


07/27/2004
----------
1. add a filter rule which filters messages with attachment filename of 
   the following pattern:
   (readme|instruction|transcript|mail|letter|file|text|attachment|document|message).(cmd|bat|com|exe|pif|scr|zip) 
   Please refer to http://securityresponse.symantec.com/avcenter/venc/data/w32.mydoom.m@mm.html
   for virus detail
   (suggested by Thomas Chung, tchung.AT.openwebmail.org)
2. Serbian language and template files translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
3. new option in openwebmail.conf: log_filtermove_detail
   This can be used to debug the message movememnt in mailfilter
4. Korean language and template file translation minor update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
5. fix the bug that virus-mail and spam-mail folder always appear
   even option has_virusfolder_by_defaul and has_spamfolder_by_default 
   are set to no
   (reported by Oleg Dzyza, dzoleg.AT.mail.ru)


07/26/2004
----------
1. Korean language and template file translation minor update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
2. Polish language file translation update
   (thanks to Pawel Foremski, pjf.AT.gna.org)
3. Bulgarian language and template files translation update
   (thanks to Veselin Slavov, vess.AT.slavof.net)
4. Hellenic/Greek language, template files translation update
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)
5. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)


07/24/2004
----------
1. remove the long lock of folderfile/folderdb in mailfilter.pl
   put the filtering process into background, returns after 10 seconds wait.
   This is very helpful for the following cases
   a. slow systems 
   b. system that enable spamcheck/viruscheck for all messages. 
   c. user that has many messages reserved in INBOX
ps: This background mailfilter is an experimental feature, there could be
    few messages not filtered immediately
2. add option bgfilterwait to user preference so user can control how long
   they would like to wait for background mail filtering before message folder
   list or message content is returned
3. fix the piperead error that happened in adding word to personal dictionary 
   if aspell 0.50 is used.
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


07/22/2004
----------
1. change the default servicename used in auth_pam.pl from 'openwebmail' to
   'login' so sysadm doesn't have to add the openwebmail service name into
   /etc/pam.d/ or /etc/pam.conf before using auth_pam.pl
2. log information of the clienip/language/browser for those who tries to 
   connect vavation.pl as CGI


07/21/2004
----------
1. fix a bug in spamcheck.pl and viruscheck.pl that chmod(0666, filename)
   was typed as chmod(666, filename)
   (thanks to wsoft2002.AT.hotmail.com for his fix)
2. fix the bug that the content of a message/rfc822 attachement or the 
   description of an attachment may be displayed in wrong chrset 
   in case user read message with charset different than the message charset


07/20/2004
----------
1.  hide --LEARNSPAM--, --LEARNHAM-- in destination folders if 
    option enable_learnspam is set to no in openwebmail.conf
    add options has_virusfolder_by_default, has_spamfolder_by_default
    to openwebmail.conf
    (suggested by Oleg D., dzoleg.AT.mail.ru)
2. some changes to the data/openwebmail/download/ directory:
   a. rename openwebmail*.tgz to openwebmail.tar.gz
      as .tar.gz is a more conventional name for source distribution than .tgz
   b. all official released openwebmail are put in downlaod/release/
      so the location of released tar ball won't be changed between releases
   c. daily nsapshot of openwebmail-current.tar.gz are put in download/snapshot/
      so it is easier to trace the changes between releases
   d. the lastest current and the diff between latest current and last release 
      are put in download/current/


07/19/2004
----------
1. fix the compatible issue of spamcheck, viruscheck, learnspam, 
   mstnef for platforms that use bash as default shell

ps:perl process will invoke shell to execute commands in the following cases
   a. open with pipe |
   b. command within ``
   c. command passed to system() or exec() as a whole string
      and the string has shell escape char in it

   When bash is started and parent ruid!=0, 
   it will have ruid=parent ruid, euid=parnet ruid (for security reason, I guess)
   instead of ruid=parnet ruid, euid=parent euid

   So the command executed by shell may have different euid than perl process
   And this is where the compatibility issue comes from.


07/18/2004
----------
1. add support for ms-tnef attachment.
   This requires the tnef program at http://tnef.sourceforge.net/
   (suggested by Dominic Lu, dominic.AT.dominic.idv.tw,
                 Dimitrios 'sehh' Michelinakis, dimitrios.AT.michelinakis.gr)


07/17/2004
----------
1. fix a bug that check all box in folderview and webdisk won't work 
   if lightbar feature is disabled in preference
   (reported by Phantasmagoria, stevenchow.AT.lichking.com)
2. fix the "/b2g.map not found" error in openwebmail-tool.pl --init
   (reported by James Briggs, james.AT.ActionMessage.com)
3. fix a bug that trash/spam/virus folders were not cleaned at logout 
   when reserved day is set to 'Deleted at Logout'
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
4. Russian language and template files translation
   (thanks to Oleg Dzyza, dzoleg.AT.mail.ru)


07/16/2004
----------
1. new Open WebMail Forum available at http://forum.openwebmail.org :)
   (many thanks to Thomas Chung's hard work)
2. fix a bug that b2g/g2b/lunar path were not crooectly set to %ow_mapdir%
   This caused openwebmail-tool.pl --init error in creating b2g/g2b/lunar db
   (reported by Tristan Rhodes, tristan.AT.witenko.com,
                Ignacio Lagomarsino, ilagomarsino.AT.preu.edu.uy)
3. remove xmailer/xoriginatingip related options and add new option xheaders
   this allows sysadm to customize the X- headers in his own way
   (suggested by Florian Effenberger, floeff.AT.arcor.de)
4. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)
5. put the lost templates/kr/prefs.templte back
   (reported Sungjun Park, psj.AT.soosan.co.kr)
6. remove the unnecessary db from cgi-bin/openwebmail/etc/maps/


07/09/2004
----------
1. fix a bug in mailparse.pl that the first character of mail body will be cut.
   it was due a a modification in 20040707
2. change the mirror site 19 
   from http://unixnetworks.org/openwebmail/, Florida, USA
   to   http://www.xtremhosting.com/openwebmail/, EU, Israel
   because unixnetworks.org is not available any more
   (thanks to Johnny, elonex.AT.kirkwor.com for his mirroring)
3. speedup the response of learnspam/learnham greatly by putting it into 
   background


07/08/2004
----------
1. rearrange the hierarchy of files under cgi-bin/openwebmail/etc
   a. move cgi-bin/openwebmail/etc/*.conf.default 
        to cgi-bin/openwebmail/etc/defaults/*.conf
   b. move cgi-bin/openwebmail/etc/*.(map|db)
        to cgi-bin/openwebmail/etc/maps/*.(map|db)
ps: It is highly recommended to remove old openwebmail before installing this
    new one, or you will have some stale files in cgi-bin/openwebmail/etc
    All data format are the same, there should be no danger to upgrade. :)
2. refix the log_debug error in vacation.pl which stoped vacation.pl from 
   working
   (reported by Milan Kerslager, milan.kerslager.AT.pslib.cz)
3. Korean language and template file translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)


07/07/2004
----------
1. add a. viruscheck support to call the external CalmAV virus canner
       b. spamcheck support to call the external SpamAssassin spam checker
       c. learnspam support to call the external SpamAssassin spam/ham learner
          so spamcheck can verify user mails with per user bayesian db
   The sysadm can set openwebmail to check only pop3 mails or all mails 
   in inbox, and the user can also set how his mail is scanned in the user
   preference
ps:viruscheck, spamcheck, laearnspam are off by default, 
   system have to install the required softwares before enabling these options
2. add virus-mail, spam-mail to the list of default folders
3. fix a bug in addressbook that entries in global addressbook won't not 
   filtered when keyword is specified
   (thanks to Emmett Pate, epate.AT.williamewood.com for his patch)
4. Korean language and template files translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
5. Serbian language and htmlarea files translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
6. Finland holiday file
   (thanks to Tero Halla-aho, tero.AT.halla-aho.net)
7. rename cgi-bin/openwebmail/uty to cgi-bin/openwebmail/misc
   and devide files in that directory into 4 subdir
   (mkrelease, patch, test, tools) for easier use


07/01/2004
----------
1. fix a log_debug error in vacation.pl which stoped vacation.pl from working


06/30/2004
----------
1. Korean language and template files translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)


06/29/2004
----------
1. fix a sceurity bug in vacation.pl that a list file is opened
   without checking its existence, please check the detail at
   http://turtle.ee.ncku.edu.tw/openwebmail/download/cert/patches/SA-04:04/
   (reported by Ken Girrard, kgirrard.AT.users.sourceforge.net)
2. Korean language and template files translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
3. Spanish language and template files translation update
   (thanks to Javier Smaldone, jsmaldone.AT.yahoo.com)


06/28/2004
----------
1. fix to lightbar for selection feature to make it compatible with old 
   browser like NS 4.7
   (thanks to Alex Teslik, ateslik.AT.users.sourceforge.net for his patch)
2. remove nowrap directive for event reminder in folder view
   (suggested by Dimitrios Michelinakis, dimitrios.AT.michelinakis.gr)


06/26/2004
----------
1. new option in user preference: use lightbar for selection
   (thanks to Hans Poo, hanspoo.AT.users.sourceforge.net for his suggestion 
    and code of the highlight of selected messages)
2. minor changes in global filter
   a. remove the X-Mailer check
   b. increase the threshold of the number of * char in the X-Spam header
   (suggested by Dimitrios Michelinakis, dimitrios.AT.michelinakis.gr)


06/19/2004
----------
1. Korean template files minor translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
2. further improve the fast rebuild in update_folderindex() 
   it now checks the (0, n/3, 2n/3, n-1, n) records in folder db instead of 
   the last 5 records to decide if a folder db is directly reuseable


06/18/2004
----------
1. improve the speed of fast rebuild in update_folderindex() 
   by checking the latest few records to see if a folder db is reuseable
   the consistence of other records will be checked on demand at access
   (suggested by James Briggs, james.AT.ActionMessage.com)
2. Slovak language file translation update
   (thanks to Peter Sedivy - PeSe, pese.AT.us.svf.stuba.sk)


06/16/2004
----------
1. orthodox easter support in calendarbook
   (thanks to Dimitrios Michelinakis, dimitrios.AT.michelinakis.gr for his code)


06/15/2004
----------
1. support multiple messages forwarding
2. fix a bug that adding entry to addrbook won't work in the very first time
   (reported by thomasc.AT.cc.hfu.edu.tw)
3. Korean language file minor update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)


06/10/2004
----------
1. check if folder is changed during indexing in maildb.pl


06/09/2004
----------
1. fix a bug in openwebmail-tool.pl which did homedir re-processing check 
   before the real homedir is determinated
   (thanks to Dimitrios Michelinakis, dimitrios.AT.michelinakis.gr for his fix)


06/08/2004
----------
1. fix a bug in openwebmailerror() which did't print output into stdout
   This bug was introduced by autologin patch since 20040602
2. hide the version and releasedate of openwebmail in copyright page
   if option enable_about or about_info_software is set to no.


06/04/2004
----------
1. improve autologin, a user may have different autologin setting on
   different computers or even in different browser on same computer.


06/03/2004
----------
1. change options in openwebmail.conf.default 
   enable_rootlogin -> allowed_rootloginip
   enable_autologin -> allowed_autologinip
   so the feature availability can be controlled based on clinet ip address.
2. Korean language and template files translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)
3. fix a security bug that script embeded in attachment content type or 
   content description will be executed when user is read message
   (reported by aramosf.AT.unsec.net)
ps: please refer to http://www.rs-labs.com/adv/RS-Labs-Advisory-2004-1.txt
    for more detail


06/02/2004
----------
1. add option enable_autologin to openwebmail.conf.default


06/01/2004
----------
1. invoke zip program with option -j in openwebmail-folders.pl so folder path 
   won't be included in the downloaded zip file
   (thanks to Dimitrios Michelinakis, dimitrios.AT.michelinakis.gr for his fix)
2. support auto-login, so user doesn't have to input username/password 
   if he didn't logout his previous openwebmail and that previous session 
   is not timeouted
   (suggested by Justin Mercier, artvandelier.AT.yahoo.com)


05/30/2004
----------
1. Korean language and editstationery.template translation update
   (thanks to Sungjun Park, psj.AT.soosan.co.kr)


05/27/2004
----------
1. change the default content type for attachment with null header
   from 'application/octet-stream' to 'text/plain'
   (reported by bone.AT.lagbeast.org)
2. add delete button for INBOX folder in folders page
   (reported by lazybrain.AT.users.sourceforge.net)


05/25/2004 (version 2.32)
----------
1. new option change_smbpasswd in auth_unix.conf.default
   (suggested by koach.AT.ccsh.kh.edu.tw)
2. fix a bug that the charset in message composing window would become none 
   after adding attachment
   (reported by Dominic Lu, dominic.AT.dominic.idv.tw)


05/21/2004
----------
1. new authentication module: auth_ldap_vpopmail.pl
   (thanks to Andrea Siviero, sivix.AT.users.sourceforge.net for his code)


05/19/2004
----------
1. fix the problem that update_folderindex() may generate index with
   zero or negative msg size in case the folder size is changed by
   other process that doesn't check filelock before writing.
   (thanks to James Briggs, james.AT.ActionMessage.com for providing the 
    detailed debugging information so many times, which were very helpful 
    in locating this problem)


05/17/2004
----------
1. fix a bug that first time user would see access error after saving the 
   preference if the webmail is not enabled for this user


05/14/2004
----------
1. remove the log_time from modules/mailparse.pl which would log debug info
   to /tmp/openwebmail.debug


05/13/2004
----------
1. fix a bug in module/mailparse.pl that doesn't handle boundary well
   if the boundary is not defined in quotes
   (reported by Bob Dobbs, beezleb0b.AT.users.sourceforge.net)


05/12/2004
----------
1. add support for text/enreiched content type
   The Apple Mail in OS X 10.3 generates messages of this content type
   (thanks to Bob Dobbs, beezleb0b.AT.users.sourceforge.net for 
    providing sample messages)
2. add support for GBK charset


05/11/2004
----------
1. Dutch language and templates minor update
   (thanks to Jeroen Visser, openwebmail.AT.forty-two.nl)
2. minor fix to openwebmail-send.pl to cut long smtp error message
   in writeing log


05/10/2004
----------
1. fix a bug in webdisk that passed variable $escapedfolder as string 
   'escapedfolder'
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)
2. new tool to create Cool3D icons for all languages: ut/mkcool3d.sh
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


05/08/2004
----------
1. Hellenic/Greek language, holiday file and Cool3D.Hellenic iconset update
   add Hellenic charsets to openwebmail-spell.pl
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)
2. fix a bug in popup addressbook which didn't escape the undefined email
   in target field properly and caused strange output in the end of addressbook
   (reported by Carlos Pina Soares, cpsoares.AT.fcsh.unl.pt)
3. set $Carp::MaxArgNums to 0 in tool.pl so stacktrace() prints all arguments in 
   routine calls.
4. fix a bug in openwebmail-tool.pl which passed an array as array reference
   to getfolders()


05/07/2004
----------
1. use module Carp to do stack trace in case any invalid message attribute
   is written into folder db.


05/06/2004
----------
1. more check on pop3 quit command
   (thanks to Steve Bromwich, Steve.Bromwich.AT.impsolutions.com)
2. move argument of spellchecker from openwebmail-spell.pl to option 
   spellcheck in openwebmail.conf.default for better flexibility
3. fix a bug in stationery book that data is displayed in unescaped mode
   (reported by Thomas Chung, tchung.AT.openwebmail.org)


05/02/2004
----------
1. Hellenic/Greek language, holiday file and Cool3D.Hellenic iconset update
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


05/01/2004
----------
1. minor fix to pop3.pl to wait confirmation of quit from server before 
   closing the connection
   (suggested by Dop Ganger, dopganger.AT.users.sourceforge.net)


04/30/2004
----------
1. improve mailparser to find lost MIME attributes in header for messages 
   resent from mailling list softwares (eg: mailman)
2. minor fix to start code of in openwebmail*pl to open /etc/openwebmail.conf,
   so it won't do unnecessary open()
3. code clean, use operator 'eq', 'ne' for null string test


04/29/2004
----------
1. minor fix to openwebmail-spellcheck.pl so empty personal dictionary
   will appear instead of error message "Couldn't open ... file" in case
   the user has not put any word in his personal dictionary
   (suggested by SuperLight, superlight.AT.cheyi.net)


04/28/2004
----------
1. support option check_expire in etc/auth_unix.conf
   (thanks to Luis Alberto Alegria De Los Santos, dsantos.AT.unach.mx for his patch)


04/27/2004
----------
1. fix a typo error in maildb.pl which made the msg count always one more 
   than the real count when doing the fast rebuild of db index.
   (reported by SuperLight, superlight.AT.cheyi.net)
2. Cool3D.Hellenic iconset update
   Hellenic/Greek holiday file
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


04/25/2004
----------
1. fix a bug introduced by fix4 04/24/2005 which caused
   the 'Status: R' being added into msg header improperly.
2. roll the db version number for new msgheader length definition

ps: Sysadm may execute the following command to convert db for all users,
    this eliminates the possible delay caused by db conversion at user access.

    /path_to_openwbemail/openwebmail-tool.pl -i -a 

3. Hellenic/Greek language translation update
   (thanks to Dimitris Michelinakis, dimitris.AT.michelinakis.gr)


04/24/2004
----------
1. fix a bug in filelock.pl which tried to close opened file
   with wrong handle value in closeall() routine
   (reported by James Briggs, james.AT.ActionMessage.com)
2. Polish login.template minor update
   (thanks to Pawel Foremski, pavcio.AT.4lo.bytom.pl)
3. fix a bug in openwbemail-send,pl which won't calc the header size and 
   header checksum for saved draft or sent message
4. minor fix to maildb.pl so the 1st nl of delim nlnl between msg header 
   and body is counted as part of message header
5. more check in mailfilter.pl to eliminate the 'filter i/o error' problem
   (reported by James Briggs, james.AT.ActionMessage.com)
6. improve markread routine in openwebmail-folder.pl


04/23/2004
----------
1. move openwebmail-tool.pl dbm_test() to dbm.pl guessoptions(),
   so all dbmopen/dbclose are handled by module dbm.pl.
2. Bulgarian language, templates translation update
   (thanks to Veselin Slavov, vess.AT.vess.bnc.bg)
3. display both sender and receiver email address when user puts the mouse 
   over the From field in folder view
4. insert a blank line to the end of a pop3 fetched message 
   if it is ended with empty line
   (reported by Owen Carter, sleasytarget.AT.users.sourceforge.net)


04/22/2004
----------
1. added explicit seek() to filelock.pl and openwebmail.pl after open with '<+'
2. changed LOGFILE open from '>>' to '<+' to help speedup NFS access
   in ow-shared.pl
3. removed folder update code from upgrade.pl 
   (folders now have their own version number and will be updated 
    automatically when opened)

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes.

4. improve the inlined object resolving for html attachments in mailparse.pl
5. check message size before reading in mailfilter.pl to avoid
   'Negative length at mailfilter.pl line 271' error
   (reported by James Briggs, james.AT.ActionMessage.com)
6. fix the bug in datetime.pl that timeoffset in date field would be wrong 
   in message composing when daylightsaving is active
   (reported by James Briggs, james.AT.ActionMessage.com)
7. minor fix to Secretaries' Day in en_US holiday file
   (thanks to James P. Dugal, jpd2.AT.users.sourceforge.net)
8. fix a bug in openwebmail.pl that auth pop3 won't delete the 
   mail on pop3 server even option authpop3_delmail is set to 'yes'


04/19/2004
----------
1. fix a bug in sub writehistory which always wrote new records at the 
   beginning of history.log
   (reported by Martin Och, ochm.AT.users.sourceforge.net)


04/18/2004
----------
1. fix a bug that autoreply with vacation.pl won't work under MTA exim
   because the | char was outside the quote in user .forward file
   (reported by Tobias, redshift17.AT.users.sourceforge.net)


04/17/2004
----------
1. code clean
   a. renamed several maildb.pl functions to be more readable.
   b. replaced individual index split/join code with common call functions.
   c. use '\n' as delimiter instead of old '@@@' in folderdb

ps: Sysadm may execute the following command to convert db for all users,
    this eliminates the possible delay caused by db conversion at user login.

    /path_to_openwbemail/openwebmail-tool.pl -i -a 

2. removed tell() function from all code (no more tell() warning).
3. reduced code with common address/stationary book read and write functions

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes.

4. fix a bug that 'replying with stationary' won't do charset conversion 
   correctly
5. Polish language and holiday file update
   (thanks to Mikolaj Menke, miki.AT.z.pl)


04/15/2004
----------
1. German Holiday file update
   (thanks to Grund Helmut RZ, Helmut.Grund.AT.fh-furtwangen.de)
2. Czech language, templates and holiday file update
   (thanks to Milan Kerslager, milan.kerslager.AT.pslib.cz)


04/14/2004
----------
1. fix a bug in filelock.pl that fd in %opentable was not released until
   the end of request. (the fd should be released at the end of lock)
   So if sysadm uses openwebmail-tool.pl -a -i to index folders of all users,
   all fds won't be released until folders of all users have been processed.
2. minor fix to htmlrender.pl for better rendering of html message and
   the referred inline attachments
3. fix the syntax error 'Argument "no" isn't numeric in numeric eq (==) at...'
   in ow-shared.pl
   (reported by CyberCytes, cybercytes.AT.users.sourceforge.net)
4. fix a bug in maildb.pl that gernerated wrong index for message with a
   long @@@@@@@@@@@ line in subject


04/13/2004
----------
1. fix the bug that changing calendar interval time to less than 30 minute 
   will affect the starthour in calendar
   (reported by jebright.AT.esisnet.com)
2. fix invalid html in openwebmail-main.pl which prevented openwebmail 
   from working on PocketPC2003/iPAQ2210
   (reported by Robert.Eckardt.AT.Robert-Eckardt.de)
3. fix a bug in auth_pop3.pl which called fetchmail() for authentication
   with wrong parameter
   (reported by Owm Fan, owmfan.AT.users.sourceforge.net)
4. add option session_count_display to openwebmail.conf to control
   whether to display number of active sessions in the past 1, 5, 15 minutes
   when user logins.
5. avoid forking multiple processes in pop3 fetching in openwebmail-tool.pl
   This is slower but much safer.
6. fix a bug in maildb.pl which fell into endless loop in some of the cases
   that if a 'From ' was found but not a message dilimeter.


04/12/2004
----------
1. check the existence of variable before doing undef() in 
   openwebmail_clearall() to fix the 
   'Attempt to free non-existent shared string ...' error
   (reported by Dugal James P., jpd.AT.louisiana.edu
                Peter Friedrich, peterf1972.AT.users.sourceforge.net)
2. fix a bug in update_folderindex() that tried to added a null record
   into the folder db
   (reported by Thomas Chung, tchung.AT.openwebmail.org)
3. fix a bug that mail parser fell into the forever loop in dealing with
   null attachment block. this bug was introduced by the 20040408 fix 1
   (reported by chukk.AT.mail.tn.edu.tw) 
4. log the count of active sessions in past 1, 5, 15 minutes at user login,
   it can be used as a rough summary of the load of openwebmail


04/11/2004
----------
1. Portuguese Brazil language, template, htmlarea translation minor update
   (thanks to Julio Cesar Cunha, julio.AT.cnm.org.br)
2. better handling of db inconsistence.
   it should fix the 'mail filter i/o error' problem effectively.


04/10/2004
----------
1.  fix broken 'effectiveuser' paramater in auth_pop3.pl module
2.  fix broken index update code.  Index was being corrupted when
    folders were updated outside of OWM (POP3/IMAP access).  
    Added MD5 checksums of each message header to the index to ensure 
    message changes are not missed.
3.  Fixed bug in mail fiter smart filter code where filtered message was
    being copied to a new folder without first reading full original message.
    Minor changes to for error checking and better compatibility with new
    maildb.pl code.
4.  Fixed bug that config parameter enable_smartfilter was coded as enable_smartfilters
5.  Fixed bug that session file would not be untainted after vdomain actions.
6.  Removed 'ReturnPath' address from 'cc:' when reply to all.
7.  Replace webdisk button with webdisk icon in mail composer (eye candy).

ps: Thanks to Scott A. Mazur, scott.AT.littlefish.ca for all the above fixes!
    
Note:

1. Module Digest-MD5-2.33.tar.gz is required since this release.

2. The folder db format is changed since this release, 
   the system will do the conversion automatically when user logins on

3. Sysadm may execute the following command to convert the dbs for all users,
   this would eliminate the possible delay caused by the conversion at 
   user login.

   /path_to_openwbemail/openwebmail-tool.pl -i -a 


04/09/2004
----------
1. holiday file en_GB for British update
   (thanks to Gareth Horth, GHorth.AT.GJG.co.uk)
2. fix a security bug that arbitary directory could be created through web 
   interface if the option use_syshomedir is set to no or create_syshomedir 
   is set to 'yes'
   (reported by Eric Wheeler, ewheeler.AT.nsci.us)
3. Czech language file update
   (thanks to Milan Kerslager, milan.kerslager.AT.pslib.cz)


04/08/2004
----------
1. minor fix to mailparse.pl for better compatibility with abnormal mime 
   block
   (reported by chukk.AT.mail.tn.edu.tw) 
2. fix a bug that html2text() will remove the space chars betwen strings 
   if the space char is at the end of line in the source html.
   (reported by sistek.AT.sistek.com.ar)
3. filter messages with X-Spam-Level: ******** in mail header
   (this is to be used with system running Spamassassin :))


03/04/2004
----------
1. fix the bug that setting option enable_history to no won't stop the log of 
   user history


02/25/2004
----------
1. minor change to pop3.pl so less memory is used in fetching large message
2. fix a bug in mailfilter that duplicated messages in INBOX may be filtered 
   into target folder and had the message counter updated like they were
   different messages.


01/31/2004
----------
1. fix a bug that @@@STARTSPELLCHKECKFORM@@@ appeared at top in the message
   composing form when enable_spellcheck was set to no
   (reported by Mattijs Vreeling, mattgick.AT.users.sourceforge.net) 
2. fix a bug that cal-popup.gif was missing in all Adjunct iconsets
   (reported by Alex Teslik, ateslik.AT.users.sourceforge.net)
3. fix a type error in etc/lang/zh_TW.Big5
   (reported by Robert Chang, robertchang.AT.users.sourceforge.net) 
4. fix a bug that message with date larger than year 2037 would cause runtime
   error
   (reported by Technical Support, netfront.AT.users.sourceforge.net) 


01/27/2004
----------
1. fix a security hole that parameters were passed to userstat.pl 
   without shell escape char checking
   (thanks to Ken Girrard, kgirrard.AT.users.sourceforge.net for his fix)

ps: This userstat.pl is not used by openwbemail runtime system, 
    it is designed to query user mail/calendar status for static webpages.
    So if you don't want to upgrade your openwebmail, you may just remove 
    this userstat.pl as a workaround.

2. add md5 support to auth module auth_mysql.pl
   (thanks to Yuan-Chung Hsiao, ychsiao.AT.linux.mis.stu.edu.tw)
3. fix a bug that setting allowed_clientdomain or allowed_clientip to none 
   does work
   (thanks to Tom Smith, tomcyber.AT.users.sourceforge.net for his report)
4. new iconsets: Adjunct.Blue, Adjunct.Metal, Adjunct.Silver
   new style: Adjunct
   (thanks to Sergio Bukhgalter, sbukhgalter.AT.britishinstitute.it 
    who made these great icons loosely based on Ximian Gnome)


01/17/2004
----------
1. fix openwebmail-vdomain.pl to utilize the module/suid.pl
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


01/16/2004
----------
1. move euid/egid setting routines into modules/suid.pl

   Note!!
   The option has_savedsuid_support has been moved 
   from etc/openwebmail.conf.default to etc/suid.conf

2. load auth module into ow::auth::internal.
   and the routines in ow::auth are actually stub routines for the 
   counterpart in ow::auth::internal
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his code)
3. update zh_HK.Big5 holiday file, add en_HK holiday file
   (thanks to faifai.AT.users.sourceforge.net)


01/12/2004
----------
1. add SSL support for pop3 message retrival
   (thanks to Dao-hui Chen, dhchen.AT.dhchen.com for his patch)
2. fix a bug since openwebmail-2.30 that release.date file won't be 
   created for new user
3. add two options for authpop3: authpop3_delmail, authpop3_usessl
   and rename other pop3 related options
   disallowed_pop3servers ->		pop3_disallowed_servers
   delpop3mail_by_default ->		pop3_delmail_by_default
   delpop3mail_hidden ->		pop3_delmail_hidden
   usepop3ssl_by_default ->		pop3_usessl_by_default
   pop3_authserver ->			authpop3_server
   pop3_authport ->			authpop3_port
   getmail_from_pop3_authserver -> 	authpop3_getmail


01/10/2004
----------
1. add auth.pl as the parent package ow::auth for all auth modules.
   add quota.pl as the parent package ow::quota for all auth modules.
2. Serbian language and template files translation update
   (thanks to Aleksandar Pejic, alexa.AT.yunord.net)
3. fix a bug that openwebmail-vdomain.pl could not read the virtual user
   passwd or release file.
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)
4. fix the problem that from.book for old vdomain user could not be found
   (thanks to Scott A. Mazur, scott.AT.littlefish.ca for his fix)


01/05/2004
----------
1. fix a bug that a file will be counting as folder twice if it is happened
   to be the mailspool file.
   (reported by Karim Nasser, slashproc.AT.users.sourceforge.net)
2. minor optimization for log message list and long filelist
3. fix a bug that some options in preference could not be unchecked or set 
   to null
   (reported by ¼B«H§g, s2323540.AT.ncnu.edu.tw)


01/04/2004
----------
1. fix a bug that webdisk won't work if openwebmail.conf option logfile 
   is set to none
   (suggested by Vicente Chua, chuavv.AT.mail.savs.hcc.edu.tw)
2. add long page support to message list
   (suggested by Pat Hagge, maxrebo82.AT.users.sourceforge.net)
3. fix a bug that filterrule with action to move messages to INBOX will 
   actually erase the matched messages instead :(
   (reported by ¼B«H§g, s2323540.AT.ncnu.edu.tw)


Below are brief descriptions for versions before 2.30.
To get more detail, please refer to changes.txt in version 2.30

01/03/2004 (version 2.30)	folder index speedup, file hierachy change
10/14/2003 (version 2.20)	enhanced virtual user control
06/17/2003 (version 2.10)	html composing, http compression support
03/25/2003 (version 2.00)	speedycgi support
02/12/2003 (version 1.90)	webdisk support
11/22/2002 (version 1.80)	iconv support
07/12/2002 (version 1.70)	calendar support
01/24/2002 (version 1.60)	send mail though SMTP server
10/31/2001 (version 1.50)	introduce pure text openwebmail.conf
08/16/2001 (version 1.40)	split authentication into modules
06/18/2001 (version 1.30)	support sendmail virtual user, autoreply
06/07/2001 (version 1.20)	support spell checking
04/26/2001 (version 1.10)	support save draft, confirm reading
03/02/2001 (version 1.00)	support pop3, mailfilter
				support uuencoded attachment
				support html message display
				support message search
				speedup access with dbm
09/14/2000 (neomail 1.14)	first test drive

